import subprocess
import unittest

import os
import shutil
from mock_decorators.function_mock import FunctionMockCheckCall

from git_cloner.model.repository import Repository

test_dir = "/tmp/test_tmp"


class TestRepository(unittest.TestCase):
    def test_add_remote(self):
        pass

    def setUp(self):
        shutil.rmtree(test_dir, True)
        os.makedirs(test_dir, exist_ok=True)

    def tearDown(self):
        shutil.rmtree(test_dir, True)

    @FunctionMockCheckCall(subprocess, "run", expected_times=2)
    def test_init_git_and_check(self):
        rep_dir = "/tmp/test_tmp/git"
        os.makedirs(rep_dir, exist_ok=True)
        rep = Repository("/tmp/test_tmp/git")
        rep.init_git()
        self.assertTrue(rep.check_git())
        shutil.rmtree(rep_dir, True)

    def test_git_check_normal_dir(self):
        rep = Repository("/tmp/test_tmp")
        self.assertFalse(rep.check_git())
        pass
